using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Runtime.Serialization;
using Syncfusion.Windows.Forms.Tools;

namespace CombineDockingWindows
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel panel1;
		private Syncfusion.Windows.Forms.Tools.DockingManager dockingManager1;
		private System.ComponentModel.IContainer components;

		private ChildForm child1 = new ChildForm();
		private Child2 child2 = new Child2();
		private Hashtable childDockStates = new Hashtable();

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.panel1 = new System.Windows.Forms.Panel();
			this.dockingManager1 = new Syncfusion.Windows.Forms.Tools.DockingManager(this.components);
			((System.ComponentModel.ISupportInitialize)(this.dockingManager1)).BeginInit();
			// 
			// panel1
			// 
			this.panel1.BackColor = System.Drawing.Color.Gold;
			this.dockingManager1.SetEnableDocking(this.panel1, true);
			this.panel1.Location = new System.Drawing.Point(1, 23);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(118, 314);
			this.panel1.TabIndex = 1;
			// 
			// dockingManager1
			// 
			this.dockingManager1.DockLayoutStream = ((System.IO.MemoryStream)(resources.GetObject("dockingManager1.DockLayoutStream")));
			this.dockingManager1.HostControl = this;
			this.dockingManager1.SetDockLabel(this.panel1, "Parent Panel");
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(368, 338);
			this.IsMdiContainer = true;
			this.Name = "Form1";
			this.Text = "Form1";
			this.MdiChildActivate += new System.EventHandler(this.Form1_MdiChildActivate);
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.dockingManager1)).EndInit();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			child1.MdiParent = this;
			// Uncommenting out this like seems to fix the problem, (in this instance)
			//child1.WindowState = FormWindowState.Maximized;
			child1.Show();
			
			child2.MdiParent = this;
			child2.Show();
		}


		public void AddDockWindows( Syncfusion.Windows.Forms.Tools.DockingManager manager )
		{
		}

		public void HideDockWindows( Syncfusion.Windows.Forms.Tools.DockingManager manager )
		{
			manager.SetEnableDocking(this.panel1, false);
		}


		private void Form1_MdiChildActivate(object sender, System.EventArgs e)
		{
			Console.WriteLine("MDI Child Activate");
			if ( (this.ActiveMdiChild != null) && (this.ActiveMdiChild == this.child1) )
			{
				// Get the hashtable of the controls to dock (keyed by the description)
				Hashtable dockWindows = this.child1.GetDockWindows();

				IDictionaryEnumerator myEnumerator = dockWindows.GetEnumerator();
				while ( myEnumerator.MoveNext() )
				{
					string description = myEnumerator.Key as string;
					Control dockItem = myEnumerator.Value as Control;

					this.dockingManager1.SetEnableDocking(dockItem, true);
					this.dockingManager1.SetDockLabel(dockItem, description);

					if ( childDockStates.ContainsKey(dockItem) )
					{
						System.IO.MemoryStream dockState = childDockStates[dockItem] as System.IO.MemoryStream;
						if ( dockState != null )
						{
							dockState.Position = 0;
							AppStateSerializer serialiser = new AppStateSerializer(SerializeMode.BinaryFmtStream, dockState);
							this.dockingManager1.LoadDockState(serialiser, dockItem);
						}
					}
				}
			}
			this.ActiveMdiChild.Deactivate += new EventHandler(child_Deactivate);
		}

		private void child_Deactivate(object sender, EventArgs e)
		{
			Console.WriteLine("MDI Child DeActivate");
			Form deactivatingChild = sender as Form;
			if ( (deactivatingChild != null) && (deactivatingChild == this.child1) )
			{

				// Get the hashtable of the controls to dock (keyed by the description)
				Hashtable dockWindows = this.child1.GetDockWindows();

				// Use the dock hash to save the dock states, and turn off the window
				IDictionaryEnumerator myEnumerator = dockWindows.GetEnumerator();
				while ( myEnumerator.MoveNext() )
				{
					string description = myEnumerator.Key as string;
					Control dockItem = myEnumerator.Value as Control;

					System.IO.MemoryStream dockState = new System.IO.MemoryStream();
					childDockStates[dockItem] = dockState;
					AppStateSerializer serialiser = new AppStateSerializer(SerializeMode.BinaryFmtStream, dockState);
					this.dockingManager1.SaveDockState(serialiser, dockItem);
					serialiser.PersistNow();

					this.dockingManager1.SetEnableDocking(dockItem, false);
				}
			}
			deactivatingChild.Deactivate -= new EventHandler(child_Deactivate);
		}
	}
}
